# CraftPresence

## [v1.6.0](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v1.6.0) (2021-06-10)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/compare/v1.5.8.2...v1.6.0) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- [Change] Final polish + Documentation adjustments  
    - With this, all the new systems should be stable to deploy as all tested cases have passed without issue at this stage.  
- [Fix] Allow an empty string to trigger the migration layer  
    - The `ignoreCallback` was able to be an empty string, and using the `IsNullOrEmpty` check here caused empty string values not to be removed. This check has now been corrected.  
- [Fix] Fixed regressions effecting <=1.12.1 clients from v1.5.0  
    - Fixed instances of the key,value pair being overriden during traversal (Which while performs normally on newer clients, 1.12.1 and below error with an invalid key.  
    - Fixed an issue where logging for events was still showing up due to `log\_output` not having a proper default value.  
- [Fix] Regression Fixes and minor tweaks  
    - Fixed regressions preventing migration layers and ignore callbacks from working properly  
    - Adjusted event logging to use `log\_output` flag  
- [Change] Added a new migration layer system  
    - Added `Migration\_Functions`. This new file will hold any and all migration layers going forwards.  
    - Added `schema` identifiers to AddOn Info and Config Data. This identifier is not editable in the config GUI, and should not be modified by the user. It is used within the backend to determine how new/old your config is, and how it should be updated to the latest schema (Defined in the TOC)  
    - Edited the process callback tooltip to be more easily readable  
    - Removed `GetVersion` and `GetVersionString`. Added `GetAddOnInfo` in it's place to use the more-defined table systems.  
- [Fix] Regression Fixes for v2 Implementation  
    - Further fixes needed to preserve backwards compatibility  
- [Change] Event Callback Rewrite v2  
    Notes:  
    - [Backend] `GetDynamicReturnValue` is now able to return multiple values, depending on the function being used. The inner `value` is converted and persisted as a `table` to work with this, with the first table argument being used for the loop limiter. (IE returning the first value as a function will signal to the app you want it to continue iterating through that function instead of returning that function, which is intended here).  
    - [Breaking] `Ignore Callback` has been renamed to `Process Callback`, and is now able to take two return args for `ignore\_event` and `log\_output`  
    - [Change] Moved up the deprecated functions date to `v1.7.0`  
